package cz.muni.fi.pv168.project.model.db;

import cz.muni.fi.pv168.project.model.EditableModel;
import cz.muni.fi.pv168.project.ui.dialog.error.ErrorDialog;

import javax.swing.DefaultListModel;

public abstract class AbstractDataModel<E> extends DefaultListModel<E> implements EditableModel<E> {

    @Override
    public void setElementAt(E element, int index) {
        try {
            update(element);
        } catch (Exception e) {
            e.printStackTrace();
            ErrorDialog.show("Error when editing " + element, e);
        }
        super.setElementAt(element, index);
    }

    @Override
    public void addElement(E element) {
        try {
            add(element);
        } catch (Exception e) {
            e.printStackTrace();
            ErrorDialog.show("Error when adding " + element, e);
        }

        super.addElement(element);
    }

    @Override
    @SuppressWarnings("unchecked") // safe
    public boolean removeElement(Object obj) {
        try {
            delete((E) obj);
        } catch (Exception e) {
            e.printStackTrace();
            ErrorDialog.show("Error when removing " + obj, e);
        }
        return super.removeElement(obj);
    }
}
