package cz.muni.fi.pv168.project.ui.dialog;

import cz.muni.fi.pv168.project.model.ComboBoxModelAdapter;

import javax.swing.JComboBox;
import java.util.Collection;

public class ComboBoxDialog<T> extends AbstractLaidOutDialog<T> {

    private final JComboBox<T> comboBox;

    public ComboBoxDialog(Collection<T> entities) {
        comboBox = new JComboBox<>(ComboBoxModelAdapter.fromCollection(entities));
        addLabeledField("Select :", comboBox, labelGbc, middleComponent, getRow());

        // gray out button when nothing is initially selected
        getOkButton().setEnabled(false);
        comboBox.addActionListener(e -> getOkButton().setEnabled(true));
    }

    @SuppressWarnings("unchecked") // safe
    @Override
    T getEntity() {
        return (T) comboBox.getSelectedItem();
    }
}
