package cz.muni.fi.pv168.project.ui.main.panel;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

public class WelcomePanel {

    private final JPanel panel;
    private static final String WELCOME_MESSAGE =
            "Welcome to to:do, your daily task reminder.\n" + "\n" +
            "You can use the toolbar buttons above to add, edit, or delete tasks and categories.\n" +
            "Switch between tasks and categories using the tabs.\n" +
            "Click on a task in the list on the left to see details.";

    public WelcomePanel() {
        var welcomeTextArea = new JTextArea(WELCOME_MESSAGE);
        welcomeTextArea.setFont(new Font(Font.SANS_SERIF, welcomeTextArea.getFont().getStyle(), 20));
        welcomeTextArea.setLineWrap(true);
        welcomeTextArea.setWrapStyleWord(true);
        welcomeTextArea.setEditable(false);
        welcomeTextArea.setMinimumSize(new Dimension(200, 50));

        panel = new JPanel(new BorderLayout());
        panel.setBorder(BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.LOWERED), new EmptyBorder(50, 50, 50, 50)));
        welcomeTextArea.setBackground(new Color(panel.getBackground().getRGB()));
        panel.add(welcomeTextArea);
    }

    public JPanel getPanel() {
        return panel;
    }
}
